DA88 DW 29EA   (song pattern position - start address EA29)

E800 DB 00     (speaker state - set/unset)


; wait for BC*26-9 T-cycles = approx. BC * 7.43us
D4AF DEC BC                ;6;
     LD A,B                ;4;
     OR C                  ;4; loop until
     JR NZ,D4AF            ;12/7; BC is zero
     RET                   ;10;

; play a tone
DAA7 ADD A,A               ;4; A*2 (A=pattern data)
     LD E,A                ;4;
     LD D,0                ;7;
     LD HL,6919            ;10; tones start address
     ADD HL,DE             ;11; calc tone position
     LD E,(HL)             ;7; read tone pitch (frequency)
     INC HL                ;6;
     LD B,(HL)             ;7; read tone length

     LD A,(E800)           ;13; get recent speaker state
DAB5 PUSH DE               ;11;
     XOR 10                ;7; invert speaker state
     OUT (FE),A            ;11; output to speaker
     LD C,A                ;4;

DABB DEC DE                ;6;
     LD A,D                ;4;
     OR E                  ;4; loop until
     JR NZ,DABB            ;12/7; DE is zero
     POP DE                ;10;
     LD A,C                ;4;
     DJNZ DAB5             ;13/8; loop until B is zero
     LD (E800),A           ;13; store speaker state
     RET                   ;10;

; wait for 70020 T-cycles = 20 ms
DAFA LD BC,0A84            ;10; BC = wait cycles
     CALL D4AF             ;17; call wait routine
     RET                   ;10;

; play the song
DB17 LD HL,(DA88h)         ;16; get pattern position
     LD A,(HL)             ;7;
     INC HL                ;6; update
     LD (DA88),HL          ;16; to next position

     CP FF                 ;7; end of patterns
     JR Z,DB29             ;12/7;
     AND A                 ;4; if zero
     JR Z,DAFA             ;12/7; skip sound (just wait for 20ms)
     JP DAA7               ;10; play the tone
